﻿using LeanCloud;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UserAccount : MonoBehaviour
{
    public Canvas canvas;

    public GameObject login;
    public GameObject create;

    private void Awake()
    {
        _initLogin();
        _initCreate();

        try
        {
            var curUser = AVUser.CurrentUser;
            if (curUser == null)
            {
                login.SetActive(true);
            }
            else
            {
                _ = _checkSessionAsync((bool ok) =>
                {
                    if (ok)
                    {
                        _login();
                    }
                    else
                    {
                        login.SetActive(true);
                    }
                });
            }
        } catch (Exception e)
        {
            login.SetActive(true);
        }
    }

    // Start is called before the first frame update
    void Start()
    {
        
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    private void _initLogin()
    {
        login.SetActive(false);

        var script = login.GetComponent<ui.login.Login>();
        script.loginCallback = () =>
        {
            _login();
        };

        script.createCallback = () =>
        {
            login.SetActive(false);
            create.SetActive(true);

            var createScript = create.GetComponent<ui.login.Create>();
            createScript.pwInput.text = "";
            createScript.msgText.text = "";
        };
    }

    private void _initCreate()
    {
        create.SetActive(false);

        var script = create.GetComponent<ui.login.Create>();
        script.createedCallback = (string email) =>
        {
            create.SetActive(false);
            login.SetActive(true);

            var loginScript = login.GetComponent<ui.login.Login>();
            loginScript.emailInput.text = email;
            loginScript.pwInput.text = "";
            loginScript.msgText.text = "";
        };

        script.returnCallback = () =>
        {
            create.SetActive(false);
            login.SetActive(true);
        };
    }

    private async System.Threading.Tasks.Task _checkSessionAsync(Action<bool> callback)
    {
        callback(await AVUser.CurrentUser.IsAuthenticatedAsync());
    }

    private void _login()
    {
        Debug.Log(AVUser.CurrentUser.Username);
    }
}
